unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Math;

type
  TFormMain = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Panel2: TPanel;
    PaintBox2: TPaintBox;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FormMain: TFormMain;

implementation

uses files;

{$R *.DFM}

const
  size_buf= 4096;
  max_time= 300;
  min_F= 55;
  max_F= 22050;

type
  t_data= record
            left,right: smallint;
          end;

var
  read_buffer: array[1..size_buf] of t_data;
  buf_pos    : longint;
  wave_len   : longint;
  tpoints    : array[1..max_time*44100 div 10] of smallint;
  ntpoints   : longint;
  fic        : file;
  wave_pos   : longint;

procedure Open_Wave(filename: string);
var
  Wrd   : Word;
begin
  FormMain.PaintBox1.Canvas.Pen.Color:= RGB(127,127,127);
  FormMain.PaintBox1.Canvas.Pen.Style:= pssolid;
  FormMain.PaintBox1.Canvas.MoveTo(0,FormMain.PaintBox1.Height Div 2);
  FormMain.PaintBox1.Canvas.LineTo(FormMain.PaintBox1.Width,FormMain.PaintBox1.Height Div 2);
  assignfile(fic,filename);
  reset(fic,1);
  wave_len:= (filesize(fic)-44) div sizeof(t_data);
  seek(fic,22);
  blockread(Fic,Wrd,2);
  if Wrd<>2 then
  begin
     MessageDlg('Fichier non stro',mtError,[mbOK],0);
     Halt;
  end;
  seek(fic,34);
  blockread(Fic,Wrd,2);
  if Wrd<>16 then
  begin
     MessageDlg('Fichier non 16 bits',mtError,[mbOK],0);
     Halt;
  end;
  seek(fic,44);
  buf_pos:= 0;
end;

function get_data: smallint;
var
  num   : integer;
  data  : smallint;
  a_data: t_data;
begin
  if buf_pos= 0 then blockread(fic,read_buffer,size_buf*sizeof(t_data),num);
  inc(buf_pos);
  a_data:= read_buffer[buf_pos];
  if buf_pos>=size_buf then buf_pos:= 0;
  data:= a_data.right;
  FormMain.PaintBox1.Canvas.pixels
    [round(wave_pos/wave_len*FormMain.PaintBox1.Width),
     FormMain.PaintBox1.Height+round((data-32767)/65535*FormMain.PaintBox1.Height)]:=
    RGB(63,63,127);

  inc(wave_pos);
  get_data:= data;
end;

procedure Do_P_Count;
var
  si      : smallint;
  last_si : smallint;
  last_pos: longint;
begin
  wave_pos:= 0;
  last_pos:= 0;
  last_si:= 32767;
  ntpoints:= 0;
  repeat
    si:= get_data;
    if  ((si>last_si)
    and (last_si<0) and (si>=0)) then
    begin
      inc(ntpoints);
      tpoints[ntpoints]:= wave_pos-last_pos;
      last_pos:= wave_pos;
    end;
    last_si:= si;
  until wave_pos>=wave_len;
end;

procedure Do_F;
var
  i,j   : longint;
  P_Pos : integer;
  P_data: longint;
  Txt   : TextFile;
begin
  AssignFile(Txt,FileDest);
  Rewrite(Txt);
  P_Pos:= 0;
  for i:= 1 to ntpoints-1 do
  begin
    for j:= 0 to tpoints[i]-1 do
    begin
      Inc(P_Pos);
      P_data:= tpoints[i]+round((tpoints[i+1]-tpoints[i])/tpoints[i]*j);
      P_data:= Round(1/(P_data*1/44100));
      If P_Pos Mod (44100 Div Frequence)= 0 Then
        WriteLn(Txt,P_Pos/44100:4:2,';',P_data);
      FormMain.PaintBox2.Canvas.pixels
        [round(P_Pos/wave_len*FormMain.PaintBox2.Width),
         FormMain.PaintBox2.Height-
         round((Log10(P_data)-Log10(min_F))/(Log10(max_F)-Log10(min_F))*(FormMain.PaintBox2.Height-2)-1)]:=
        RGB(127,0,0);
    end;
  end;
  CloseFile(Txt);
end;

procedure TFormMain.Button1Click(Sender: TObject);
begin
  Open_Wave(FileSource);
  Do_P_Count;
  Do_F;
  closefile(fic);
end;


procedure TFormMain.Panel1Resize(Sender: TObject);
begin
  PaintBox1.Width:= Panel1.Width-2;
  PaintBox1.Height:= Panel1.Height-2;
end;

procedure TFormMain.Panel2Resize(Sender: TObject);
begin
  PaintBox2.Width:= Panel2.Width-2;
  PaintBox2.Height:= Panel2.Height-2;
end;

procedure TFormMain.FormResize(Sender: TObject);
begin
  Panel1.Width:= FormMain.Width-24;
  Panel1.Height:= FormMain.Height Div 3;
  Image1.Top:= Panel1.Top+Panel1.Height+8;
  Image1.Left:= (FormMain.Width-Image1.Width) Div 2;
  Panel2.Width:= FormMain.Width-24;
  Panel2.Top:= Image1.Top+Image1.Height+8;
  Button1.Top:= FormMain.Height-48;
  Button1.Left:= (FormMain.Width-Button1.Width) Div 2;
  Panel2.Width:= FormMain.Width-24;
  Panel2.Height:= Button1.Top-Panel2.Top-8;
end;

procedure TFormMain.PaintBox2Paint(Sender: TObject);
begin
  PaintBox2.Canvas.Font.Color:= RGB(191,191,191);
  PaintBox2.Canvas.TextOut(
    8,round((Log10(110)-Log10(min_F))/(Log10(max_F)-Log10(min_F))*(FormMain.PaintBox2.Height-2)-1),
    '110');
  PaintBox2.Canvas.TextOut(
    8,round((Log10(220)-Log10(min_F))/(Log10(max_F)-Log10(min_F))*(FormMain.PaintBox2.Height-2)-1),
    '220');
  PaintBox2.Canvas.TextOut(
    8,round((Log10(440)-Log10(min_F))/(Log10(max_F)-Log10(min_F))*(FormMain.PaintBox2.Height-2)-1),
    '440');
  PaintBox2.Canvas.TextOut(
    8,round((Log10(880)-Log10(min_F))/(Log10(max_F)-Log10(min_F))*(FormMain.PaintBox2.Height-2)-1),
    '880');

end;

end.
